//
//  Halo.java
//  Halo
//
//  Created by lars on 23/03/2008.
//  Copyright (c) 2008 __MyCompanyName__. All rights reserved.
//
//	For information on setting Java configuration information, including 
//	setting Java properties, refer to the documentation at
//		http://developer.apple.com/techpubs/java/java.html
//

//import java.util.Locale;
import java.util.ResourceBundle;
import java.util.Locale;
import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.KeyEvent;
import java.text.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.event.*;
import static java.lang.Math.*;
import java.util.LinkedList;
import java.awt.image.*;
import java.io.*;
import javax.imageio.*;
import java.util.*;

public class Halo extends JFrame {

	private Font font = new Font("serif", Font.ITALIC+Font.BOLD, 36);
	private JFrame jf;
	
	private JMenuBar mb = new JMenuBar();
	private JMenu fileMenu = new JMenu("File");
	private JMenu toolMenu = new JMenu("Tool");
	private JMenu projectionMenu = new JMenu("Projection");
	private JMenuItem quitItem = new JMenuItem("Quit");
	private JMenuItem aboutItem = new JMenuItem("About Halo...");
	private JMenuItem saveDisplayItem = new JMenuItem("Save Display");
	private JMenuItem saveStereoItem = new JMenuItem("Save Stereo");
	private JMenuItem stereoItem1 = new JMenuItem("Stereo");
	private JMenuItem prefPane = new JMenuItem("Stereo Preferences");
	private JMenuItem fishItem = new JMenuItem("Fisheye");
	private JMenuItem sunItem = new JMenuItem("Sun Centered");
	private JMenuItem saveDataItem = new JMenuItem("SaveSpatialData");
	ImageIcon ic = new ImageIcon(getClass().getResource("DL Halo.jpg"));
	private PrefPane pp = new PrefPane();
	private AboutBox about = new AboutBox();
	private JPanel sliders = new JPanel();
	private JLabel eLabel = new JLabel("30");
	private JLabel tLabel = new JLabel("2.00");
	private JLabel rotLabel = new JLabel("1");
	private JLabel ratLabel = new JLabel("1.00");
	static JSlider elevSlider = new JSlider(JSlider.VERTICAL, -10,90,30);
	private JSlider tipSlider = new JSlider(JSlider.VERTICAL, 0,1000,200);
	private JSlider rotSlider = new JSlider(JSlider.VERTICAL, 0,1000,0);
	private JSlider ratioSlider = new JSlider(JSlider.VERTICAL, 0,300,100);
	
	private JPanel pcPanel = new JPanel();
	private JRadioButton plate = new JRadioButton("Plates", true);
	private JRadioButton column = new JRadioButton("Columns", false);
	private JRadioButton parry = new JRadioButton("Parry", false);
	private ButtonGroup bg = new ButtonGroup();
	static JButton goButton = new JButton("GO");
	static JButton saveButton = new JButton("SAVE");
	
	private double[] indexArr = {1.317, 1.313, 1.312, 1.309, 1.307};//Refractive index of ice
	
	private Font font1 = new Font("SansSerif", Font.PLAIN, 9);
	static int elevation = 30, face, reflNumb;
	static double tip = 2.0;
	static int rot = 1;
	static int crystalType = 3;
	static double ratio = 1.0, gg, constant = sqrt(3)/2;
	
	static double[] sunVector = new double[4];
	static double[] rayVector = new double[4];
	static double[] faceVector = new double[4];
	static double[] sinCoeff = new double[9];
	static double[] cosCoeff = new double[9];
	static double[] partArea = new double[8];
	static double[] rotAng = new double[4];
	static double[] orthoVec = new double[4];
	static double[][] cVector = new double[4][4];
	static double[][] cRotVector = new double[4][4];
	static double[]pol = new double[4];
	static double[][] pol0 = new double[3][4];
	
	static double x, y, z, projArea, q, f, index, index0;
	static boolean inside, refl;
	static boolean[] exposed = new boolean[8];
	static double rPar, rOrtho, tPar, tOrtho,  parComp, ortComp, indexSq;
	static double polPar, polOrtho, maxArea = 2*PI;
	static Color sky =  new Color(120, 155, 255);
	static Color cPix;
	static Color[] cPixSpec = new Color[5];	
	static final int plates = 0, columnS = 1, columnO = 2, randOri = 3;
	static int saveV = 0, projection = 0;
	static long eventNumb = 0;
	static boolean pressed = false;
	static long event;
	static double[] k1 = new double[4];
	static boolean firstTime = true;
	static java.util.List<Event>  eventList = new LinkedList<Event>();;
	static Rectangle rect = new Rectangle(0,0,0,0);
	static boolean slowUpdate = false;
	public HistoryFrame hf = new HistoryFrame();
	static boolean computationDone = false, marked = false;	
	public DrawPanel drawPanel = new DrawPanel();
	static Point dragStart = new Point(0, 0);
	static Point dragEnd = new Point(0, 0);
 	public Container c;
	static BufferedImage image;	
	static int plateMode = 0;
	static boolean crossEyed = true;
	static boolean fisheye = true;
	static boolean blackSky = true;
	
	MouseListener ml = new MouseAdapter() {//Handles the mouse drag in the main window
		public void mousePressed(MouseEvent e) {
		}
		
		public void mouseReleased(MouseEvent e) { //Handles mouse drags
			if (computationDone) {
				int width = abs(dragStart.x - dragEnd.x);
				int height = abs(dragStart.y - dragEnd.y);
				int left = 0;
				if (dragStart.x < dragEnd.x) left = dragStart.x;
				else left = dragEnd.x;
				int top = 0;
				if (dragStart.y < dragEnd.y) top = dragStart.y;
				else top = dragEnd.y;
				Rectangle rect = new Rectangle(left, top, width, height);
				if (rect.getWidth() != 0 && rect.getHeight() !=0) {
					HandleRayHistories(rect);
					dragStart.setLocation(0, 0);
					dragEnd.setLocation(0, 0);
				}
			}
		}
	};

	ActionListener al = new ActionListener() {//Handles the GO button and the crystal type selection
		public void actionPerformed(ActionEvent e) {
			if (e.getSource() == goButton) {  //Start the simulatiom
				if (plate.isSelected()) plateMode = 0; //Get crystal mode
				else if (column.isSelected()) plateMode = 1;
				else plateMode = 2;
				
				firstTime = false;
				slowUpdate = true;
				eventList.clear();	
				drawPanel.repaint();	//Simulate!		
				pressed = false;
				elevSlider.setBackground(Color.white);//Restore slider colors
				tipSlider.setBackground(Color.white);
				rotSlider.setBackground(Color.white);
				ratioSlider.setBackground(Color.white);	
				computationDone = true;	//Weare through
				saveDisplayItem.setEnabled(true);
				image = new BufferedImage(drawPanel.getWidth(), drawPanel.getHeight(),
				BufferedImage.TYPE_3BYTE_BGR); //Save the draw panel
				drawPanel.paint(image.getGraphics());
				image = image.getSubimage(0, 0, drawPanel.getWidth(), drawPanel.getHeight());
				stereoItem1.setEnabled(true);
				saveDataItem.setEnabled(true);
				
				//Change of crystal type: Enable the Go button
			} else if (e.getSource() == plate || e.getSource() == column || e.getSource() == parry) goButton.setEnabled(true);
		}
	};

	//Handles the elevation slider
	ChangeListener eListener = new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
			elevation = elevSlider.getValue();
			eLabel.setText(String.format("%3d",elevation));
			sunVector[1] = -cos(toRadians(elevation));
			sunVector[2] = 0;
			sunVector[3] = -sin(toRadians(elevation));
			sinCoeff[8] = -sunVector[3];
			cosCoeff[8] = -sunVector[1];
			gg = 270*sinCoeff[8]/cosCoeff[8];
			eventNumb = 0;
			pressed = true;
			elevSlider.setBackground(Color.red);
			goButton.setEnabled(true);
		}
	};
	
	//Handles the tip slider
	ChangeListener tListener = new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
			int v = tipSlider.getValue();
			tip = v / 100.0;
			tLabel.setText(String.format("%4.2f",v/100.0));
			eventNumb = 0;
			pressed = true;
			tipSlider.setBackground(Color.red);
			goButton.setEnabled(true);
		}
	};
	
	//Handles the recycle slider
	ChangeListener rListener = new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
			int v = rotSlider.getValue();
			saveV = v;
			//rot = v / 100.0;
			double vv = v / 1000.0;
			rot = (int) (exp(vv*log(1000)));
			rotLabel.setText(String.format("%4d",rot));
			eventNumb = 0;
			pressed = true;
			rotSlider.setBackground(Color.red);
			goButton.setEnabled(true);
		}
	};

	//Handles the length/width ratio
	ChangeListener ratListener = new ChangeListener() {
		public void stateChanged(ChangeEvent e) {
			int v = ratioSlider.getValue();
			ratio = v / 100.0;
			if (v > 100 && saveV == 0) crystalType = columnS;
			if (v > 100 && saveV != 0) crystalType = columnO;
			if (v < 100) crystalType = plates;
			if (v == 100) crystalType = randOri;
			ratLabel.setText(String.format("%4.2f",ratio));
			maxArea = PI*(1 + ratio*ratio);
			eventNumb = 0;
			pressed = true;
			ratioSlider.setBackground(Color.red);
			goButton.setEnabled(true);
		}
	};
	//Handles the muenus
	ActionListener mbl = new ActionListener() {
		public void actionPerformed(ActionEvent e) {
			if (e.getSource() == quitItem) System.exit(0);
			else if(e.getSource() == stereoItem1) {//Request if stereo picture
				if (jf != null) jf.dispose();	//Skip earlier picture , if any
				jf = new JFrame();
				String title = "";
				if (crossEyed) title = "Stereo Picture Cross-Eyed";
				else title = "Stereo Picture Normal";
				jf.setTitle(title);
				MakeStereo stereo = new MakeStereo();
				jf.add(stereo);
				stereo.repaint();
				jf.setSize(1110, 610);
				jf.setVisible(true);
				saveStereoItem.setEnabled(true);//We can now save the picture
			} else if(e.getSource() == prefPane) {//Get up the preference pane
				pp.setVisible(true);
			} else if(e.getSource() == fishItem) {
				fisheye = true;
				setTitle("Streetlight Halo/ Fisheye");
				goButton.setEnabled(true);
			} else if(e.getSource() == sunItem) {
				fisheye = false;
				setTitle("Streetlight Halo/ Sun Centred");
				goButton.setEnabled(true);
			} else if (e.getSource() == saveDisplayItem && computationDone) SaveFrame(drawPanel, "DL Halo");
			else if (e.getSource() == saveStereoItem && jf != null && jf.isVisible()) SaveFrame(jf.getContentPane(), "Stereo");
			else if (e.getSource() == saveDataItem) SaveSpatialData();
			else if (e.getSource() == aboutItem) about.setVisible(true);
		}
	};

/************************************************************************/
	public Halo() {
		
		super("");
		setTitle("Streetlight Halo / Fisheye");
		//Set up the menus
		fileMenu.add(quitItem);
		fileMenu.addSeparator();		
		fileMenu.add(saveDisplayItem);
		fileMenu.add(saveStereoItem);
		fileMenu.add(saveDataItem);
		toolMenu.add(stereoItem1);
		fileMenu.addSeparator();		
		fileMenu.add(aboutItem);
		toolMenu.addSeparator();
		toolMenu.add(prefPane);
		projectionMenu.add(fishItem);
		projectionMenu.add(sunItem);
		mb.add(fileMenu);
		mb.add(toolMenu);
		mb.add(projectionMenu);
		add(mb);
		quitItem.addActionListener(mbl);
		aboutItem.addActionListener(mbl);
		saveDisplayItem.addActionListener(mbl);
		saveStereoItem.addActionListener(mbl);
		stereoItem1.setEnabled(false);
		saveDisplayItem.setEnabled(false);
		saveStereoItem.setEnabled(false);
		saveDataItem.setEnabled(false);
		stereoItem1.addActionListener(mbl);
		prefPane.addActionListener(mbl);
		fishItem.addActionListener(mbl);
		sunItem.addActionListener(mbl);
		saveDataItem.addActionListener(mbl);
		setJMenuBar(mb);
		
		c = getContentPane();
		drawPanel = new DrawPanel();
		c.add(drawPanel);
		MouseDragOutliner outliner = MouseDragOutliner.addAMouseDragOutliner(drawPanel);
		outliner.setShape(outliner.RECTANGLE);
		drawPanel.addMouseListener(ml);
		Start();
		
		setSize(560, 610);
		setResizable(false);
		setVisible(true);
		parameterPanel();
		setDefaultCloseOperation(EXIT_ON_CLOSE);
	}
	
/************************************************************************/
	static class Event {
		public int[] pixelVector = new int[7];
	}

/************************************************************/
	public void SaveFrame(Container cp, String name) {
		if (cp == null) return;
		FileDialog fd = new FileDialog(jf);
		fd.setMode(FileDialog.SAVE);
		fd.setFile(name);
		fd.setVisible(true);
		String s1 = fd.getFile();
		String s2 = fd.getDirectory();
		name = s2 + s1 +".jpg";
		if (s2 != null) {
			BufferedImage image = new BufferedImage(cp.getWidth(), cp.getHeight(),
			BufferedImage.TYPE_3BYTE_BGR);
			cp.paint(image.getGraphics());
			image = image.getSubimage(0, 0, cp.getWidth(), cp.getHeight());
			try { ImageIO.write(image, "jpg", new File(name)); }
			catch(Throwable thr) { thr.printStackTrace(); }
		}
	}
		
/************************************************************************/
 public void parameterPanel() { //Sets up the parameter window with controls
	JFrame f = new JFrame();
	JLabel eText = new JLabel("Elevation");
	JLabel tText = new JLabel("Tip");
	JLabel cText = new JLabel("c/a");
	JLabel rText = new JLabel("Recycle");
	
	f.setTitle("Parameters");
	GridBagLayout m = new GridBagLayout();
	f.setLayout(m);
	GridBagConstraints con;
	
	con = new GridBagConstraints();
	con.gridy = 0; con.gridx = 0;
	con.gridwidth = 1;con.gridheight = 1;
	m.setConstraints(eText, con);
	f.add(eText); eText.setFont(font1);

	con = new GridBagConstraints();
	con.gridy = 0; con.gridx = 1;
	con.gridwidth = 1;con.gridheight = 1;
	m.setConstraints(tText, con);
	f.add(tText); tText.setFont(font1);

	con = new GridBagConstraints();
	con.gridy = 0; con.gridx = 2;
	con.gridwidth = 1;con.gridheight = 1;
	m.setConstraints(cText, con);
	f.add(cText); cText.setFont(font1);

	con = new GridBagConstraints();
	con.gridy = 0; con.gridx = 3;
	con.gridwidth = 1;con.gridheight = 1;
	m.setConstraints(rText, con);
	f.add(rText); rText.setFont(font1);

	con = new GridBagConstraints();
	con.gridy = 1; con.gridx = 0;
	con.gridwidth = 1;con.gridheight = 3;
	con.weighty = 3;
	con.fill = GridBagConstraints.VERTICAL;
	m.setConstraints(elevSlider, con);
	f.add(elevSlider);
	elevSlider.setFont(font1);
	con = new GridBagConstraints();
	con.gridy = 5; con.gridx = 0;
	m.setConstraints(eLabel, con);
	f.add(eLabel);  eLabel.setFont(font1);

	con = new GridBagConstraints();
	con.gridy = 1; con.gridx = 1;
	con.gridheight = 3;
	con.weighty = 3;
	con.fill = GridBagConstraints.VERTICAL;
	m.setConstraints(tipSlider, con);
	f.add(tipSlider);
	con = new GridBagConstraints();
	con.gridy = 5; con.gridx = 1;
	m.setConstraints(tLabel, con);
	f.add(tLabel); tLabel.setFont(font1);

	con = new GridBagConstraints();
	con.gridy = 1; con.gridx = 2;
	con.gridheight = 3;
	con.weighty = 3;
	con.fill = GridBagConstraints.VERTICAL;
	m.setConstraints(ratioSlider, con);
	f.add(ratioSlider);
	con = new GridBagConstraints();
	con.gridy = 5; con.gridx = 2;
	m.setConstraints(ratLabel, con);
	f.add(ratLabel);  ratLabel.setFont(font1);
		
	con = new GridBagConstraints();
	con.gridy = 1; con.gridx = 3;
	con.gridheight = 3;
	con.weighty = 3;
	con.fill = GridBagConstraints.VERTICAL;
	m.setConstraints(rotSlider, con);
	f.add(rotSlider);
	con = new GridBagConstraints();
	con.gridy = 5; con.gridx = 3;
	m.setConstraints(rotLabel, con);
	f.add(rotLabel);  rotLabel.setFont(font1);
	
	con = new GridBagConstraints();
	con.gridy = 3; con.gridx = 4;
	con.gridheight = 1;
	con.weighty = 1;
	con.fill = GridBagConstraints.VERTICAL;
	m.setConstraints(goButton, con);
	f.add(goButton);
	goButton.addActionListener(al);	
	
	con = new GridBagConstraints();
	con.gridy = 2; con.gridx = 4;
	con.gridheight = 1;
	con.weighty = 1;
	con.fill = GridBagConstraints.VERTICAL;
	m.setConstraints(pcPanel, con);
	f.add(pcPanel);
	pcPanel.setLayout(new GridLayout(3,1));
	pcPanel.add(plate);
	pcPanel.add(column);
	pcPanel.add(parry);
	bg.add(plate);	bg.add(column); bg.add(parry);
	plate.addActionListener(al);
	column.addActionListener(al);
	parry.addActionListener(al);

	/*con = new GridBagConstraints();
	con.gridy = 1; con.gridx = 4;
	con.gridheight = 1;
	con.weighty = 1;
	con.fill = GridBagConstraints.VERTICAL;
	m.setConstraints(saveButton, con);
	f.add(saveButton);
	saveButton.addActionListener(al);
	saveButton.setEnabled(false);*/	
	
	elevSlider.setPaintTicks(true);
	elevSlider.setPaintLabels(true);
	elevSlider.setMajorTickSpacing(10);
	elevSlider.setMinorTickSpacing(5);
			
	elevSlider.setPaintTicks(true);
	elevSlider.setPaintLabels(true);
	elevSlider.setMajorTickSpacing(10);
	elevSlider.setMinorTickSpacing(5);

	elevSlider.setBackground(Color.white);
	tipSlider.setBackground(Color.white);
	rotSlider.setBackground(Color.white);
	ratioSlider.setBackground(Color.white);
		
	elevSlider.setOpaque(true);
	tipSlider.setOpaque(true);
	rotSlider.setOpaque(true);
	ratioSlider.setOpaque(true);
	elevSlider.addChangeListener(eListener);
	tipSlider.addChangeListener(tListener);
	rotSlider.addChangeListener(rListener);
	ratioSlider.addChangeListener(ratListener);
	
	f.setLocation(600,0);
	f.setSize(250,590);
	f.setResizable(false);
	f.setVisible(true);
	f.setDefaultCloseOperation(DO_NOTHING_ON_CLOSE);
 }
 
/************************************************************************/
	public void ReadSliders() {
		elevation = elevSlider.getValue();
		sunVector[1] = -cos(toRadians(elevation));
		sunVector[2] = 0;
		sunVector[3] = -sin(toRadians(elevation));
		sinCoeff[8] = -sunVector[3];
		cosCoeff[8] = -sunVector[1];
		gg = 270*sinCoeff[8]/cosCoeff[8];
		int v = tipSlider.getValue();
		tip = v / 100.0;
		v = rotSlider.getValue();
		saveV = v;
		double vv = v / 1000.0;
		rot = (int)(exp(vv*log(1000)));
		v = ratioSlider.getValue();
		ratio = v / 100.0;
		if (v > 100 && saveV == 0) crystalType = columnS;
		if (v > 100 && saveV != 0) crystalType = columnO;
		if (v < 100) crystalType = plates;
		if (v == 100) crystalType = randOri;
		maxArea = PI*(1 + ratio*ratio);
	}

/************************************************************************/
	static void RotationZ (int i) {//Z axis rotation
		double temp = x;
		x = x * cosCoeff[i] + y * sinCoeff[i];
		y = -temp * sinCoeff[i] + y * cosCoeff[i];
	}

/************************************************************************/
	static void SetCrystalVectors() {
		//This makes the actual rotation, cVector keeps track of the orientation}
		for (int i=0; i<= 3; i++) 
			for (int j=1; j<=3; j++) cRotVector[i][j] = cVector[i][j];
	}

/************************************************************************/
	public void Start() { 
		sinCoeff[0] = 1;
		cosCoeff[0] = 0;
	
		sinCoeff[4] = constant;
		cosCoeff[4] = 0.5;
		
		sinCoeff[5] = constant;
		cosCoeff[5] = -0.5;	
			
		sinCoeff[6] = -constant;
		cosCoeff[6] = -0.5;
		
		sinCoeff[7] = -constant;
		cosCoeff[7] = 0.5;
		
		cVector[1][1] = 0.5;
		cVector[1][2] = constant;
		cVector[1][3] = 0;
		
		cVector[2][1] = -0.5;
		cVector[2][2] = constant;
		cVector[2][3] = 0;
		
		cVector[3][1] = 0;
		cVector[3][2] = 0;
		cVector[3][3] = 1;
		
		pol0[0][1] = 0; pol0[0][2] = 1; pol0[0][3] = 0;
		for (int i=1; i<=3; i++) 
			cVector[0][i] = cVector[1][i] - cVector[2][i];
		//Spectral colours
		cPixSpec[0] = new Color(160, 160, 255, 50);//bluish
		cPixSpec[1] = new Color(145, 255, 255,50);//bluish-green
		cPixSpec[2] = new Color(160, 255, 160,50);//greenish
		cPixSpec[3] = new Color(255, 255, 145,50);//yellowish
		cPixSpec[4] = new Color(255, 120, 120,50);//reddish
		sunVector[1] = -cos(toRadians(elevation)); //Relics from earlier Halo
		sunVector[2] = 0;
		sunVector[3] = -sin(toRadians(elevation));
		
		sinCoeff[8] = -sunVector[3];
		cosCoeff[8] = -sunVector[1];
		gg = 270*sinCoeff[8]/cosCoeff[8];
	}
	
/**********************************************************************/
	static double Area() { //This function computes the respective projected areas of the crystal faces
		double fac, scalProd;
		double slump, delta, slask;
		
		//Generate random ray from source
		slump = 2*PI*random();
		rayVector[3] = 2*random() - 1;
		rayVector[1] = sqrt(1-rayVector[3]*rayVector[3])*cos(slump);
		rayVector[2] = sqrt(1-rayVector[3]*rayVector[3])*sin(slump);
		
		for (int i=1; i<4; i++) k1[i] = rayVector[i];//Remember original direction
		
		//Generate base polarisation vectors
		slask = sqrt(k1[1]*k1[1] + k1[2]*k1[2]);
		pol0[0][1] = k1[2]/slask;
		pol0[0][2] = -k1[1]/slask;
		pol0[0][3] = 0; 
			
		pol0[1][1] = -k1[1]*k1[3]/slask;
		pol0[1][2] = -k1[2]*k1[3]/slask;
		pol0[1][3] = slask;

		//Generate random polarization
		slump = random() * 2 * PI;
		for (int i=1; i<= 3; i++)
				pol[i] = pol0[0][i] * sin(slump) + pol0[1][i] * cos(slump);
					
		projArea = 0;
		inside = false;
		for (int i=0; i<4; i++) {
			scalProd = 0;
			for (int j=1; j<=3; j++)
				scalProd = scalProd + rayVector[j] * cRotVector[i][j];
			if (i == 3) fac = 3 * constant;
			else fac = 2 * ratio;
			// scalProd = projected area
			scalProd = scalProd * fac;
			if (scalProd < 0) exposed[i] = true;//Visible area
			else exposed[i] = false;
			exposed[i + 4] = !exposed[i];
			scalProd = abs(scalProd);
			partArea[i] = scalProd;//Partial crystal area
			partArea[i + 4] = scalProd;
			projArea = projArea + scalProd;
		}
		return projArea;				//Total projected area
	}

/************************************************************************/
	static void SelectFace() {
		int k;
		double randSave = random();

		int i = 0;
		while (partArea[i] / projArea <= randSave || !exposed[i]) {//Choose a face with probability
			if (exposed[i])											//proportional to 
				randSave = randSave - partArea[i] / projArea;		//projected area}
			i = i + 1;
		}
				
		face = i;
		if (face > 3) k = face - 4;
		else k = face;
		for (int j=1; j<=3; j++)
			if (face > 3) faceVector[j] = -cRotVector[k][j];
			else faceVector[j] = cRotVector[k][j];
	}
	
/*************************************************************************/
	static void Printout(double[] v) {//For debugging
		double length = 0;
		for (int i=1; i<=3; i++) length = length + v[i]*v[i];
		System.out.println(length);
	}
	
/*************************************************************************/
	static void Printout1(double[] v1, double[] v2) {//For debugging
		double length = 0;
		for (int i=1; i<=3; i++) length = length + v1[i]*v2[i];
		System.out.println(length);
	}

/*************************************************************************/
	static double Fresnel() {
		double[] tempVector = new double[4];
		
		q = 0;
		for (int i=1; i<=3; i++) q = q + rayVector[i]*faceVector[i]; 
		
		double temp = 1 / sqrt( 1 - q*q);
		for (int i=1; i<=3; i++) { //Unit vector perp. to incidence plane, cross prod.
			orthoVec[i] = faceVector[1+i%3]*rayVector[1+(i+1)%3];
			orthoVec[i] = orthoVec[i] - faceVector[1+(i+1)%3]*rayVector[1+i%3];
			orthoVec[i] = orthoVec[i]*temp;  //Normalise
		}

		for (int i=1; i<=3; i++) { //Unit vector perp. to incidence plane, cross prod.
			tempVector[i] = orthoVec[1+i%3]*rayVector[1+(i+1)%3];
			tempVector[i] = tempVector[i] - orthoVec[1+(i+1)%3]*rayVector[1+i%3];
			tempVector[i] = tempVector[i];  //Normalise
		}
		
		//Project out polarisation components
		ortComp = 0;
		parComp = 0;
		for (int i=1; i<=3; i++) {
			ortComp = ortComp + pol[i]*orthoVec[i];
			parComp = parComp + pol[i]*tempVector[i];
		}
		polPar = parComp;
		polOrtho = ortComp;

		temp = indexSq - 1 + q*q;
		if (temp > 0) { //Not total reflexion
			double p = abs(q);
			f = sqrt(temp);
			
		double factor = sqrt(f/p);
			rPar = -(indexSq*p-f) / (indexSq*p+f); //Fresnel coefficients
			rOrtho = (p-f) / (p+f);
			
			tPar = 2*p*index / (indexSq*p+f)*factor;
			tOrtho = 2*p / (p+f)*factor;
			return ortComp*ortComp*rOrtho*rOrtho + parComp*parComp*rPar*rPar;
		} else {
			tPar = 0;
			tOrtho = 0;
			rPar = - 1;
			rOrtho = 1;
			return 1;
		}
	}
	
/************************************************************************/
	static void Reflexion() { //Reflects a unit vector in a face 
		for (int i=1; i<=3; i++)
				rayVector[i] = rayVector[i] - 2 * q * faceVector[i];
		reflNumb = reflNumb + 1;
		refl = true;
	}
	
/************************************************************************/
	static void Refraction() { //Refracts a unit vector i a face
		double temp = q*(f/abs(q)-1);
		for (int i=1; i<=3; i++)
				rayVector[i] = (rayVector[i] +temp*faceVector[i])/index;
		refl = false;
		}

/************************************************************************/
	static void NewPol(double[] orthoVec, double rPar, double rOrtho, double tPar, double tOrtho,
				double polPar, double polOrtho) {
		double[] tempVector = new double[4];
		for (int i=1; i<=3; i++) {
			tempVector[i] = orthoVec[1+i%3]*rayVector[1+(i+1)%3];
			tempVector[i] = tempVector[i] - orthoVec[1+(i+1)%3]*rayVector[1+i%3];
		}
		if (refl) {
			polPar = polPar*rPar;
			polOrtho = polOrtho*rOrtho;
		} else {
			polPar = polPar*tPar;
			polOrtho = polOrtho*tOrtho;
		}
		double temp = 1 / sqrt(polPar*polPar + polOrtho*polOrtho);
		polPar = polPar * temp;
		polOrtho = polOrtho * temp;
		for (int i=1; i<=3; i++)
			pol[i] = polPar*tempVector[i] + polOrtho*orthoVec[i];		
	}
	
/************************************************************************/
	static void EntryPoint() { //Selects an entry point on a face
		double r1, r2;
		int rotIndex;
		
		switch (face) {
			case 3: //End faces
			case 7:
				r1 = random();
				r2 = random();
				x = constant*r1*0.5;
				y = -r1*0.25 + r2*0.5;
				z = ratio*0.5;
				if (face > 3) z = -z;
				rotIndex = (int)(3*random());
				if (rotIndex != 0) 
					RotationZ(rotIndex+5); //Rotate rhomb to cover entire hexagon
				break;
			case 0://Rectangular faces
			case 1:
			case 2:
			case 4:
			case 5:
			case 6:
				x = constant*0.5;
				y = (random() - 0.5)*0.5;
				z = ratio*(random() -0.5);
				switch (face) {
					case 1: RotationZ(7); break;
					case 2: RotationZ(6); break;
					case 4: x = -x; break;
					case 5: RotationZ(5); break;
					case 6: RotationZ(4); break;
				}
				break;
		}

		inside = true;
		index = 1 / index0;
		indexSq = index*index;
	}
	
/************************************************************************/
	static void Raytrace() {
		double param = 100000.0, distance, scal1, scal2, temp;
		int k, plusMinus, tempFacet = -1;
		
		event = event*10+face;
		for (int counter=face+1; counter<=face+7; counter++) {
			if (counter%8 == 3 || counter%8 == 7) distance = ratio*0.5;
			else distance = constant*0.5;
			if (counter%8 < 4) {
				k = counter%8;
				plusMinus = 1;
			} else {
				k = counter%8 - 4;
				plusMinus = -1;
			}
			scal1 = (rayVector[1]*cRotVector[k][1] +
				rayVector[2]*cRotVector[k][2] +
				rayVector[3]*cRotVector[k][3])*plusMinus;
			if (scal1 > 0) {////
				scal2 = x*cRotVector[k][1] + y*cRotVector[k][2] + z*cRotVector[k][3];
				scal2 = scal2 * plusMinus;
				if (distance >= scal2) {///
					temp = (distance - scal2) / scal1;
					if (temp < param) { //Find the nearest surface
						param = temp;
						tempFacet = counter%8;
					}//if
				}///if
			}////if
		}//for
		face = tempFacet;
		x = rayVector[1]*param + x;
		y = rayVector[2]*param + y;
		z = rayVector[3]*param + z;
		if (face > 3) k = face - 4;
		else k = face;
		for (int j=1; j<=3; j++) 
			if (face > 3) faceVector[j] = -cRotVector[k][j];
			else faceVector[j] = cRotVector[k][j];
}
	
/************************************************************************/
	static void SetIndex() { //Sets a refractive index of ice
		double lamda = 4*random();
		int rrnd = (int)lamda;
		index0 = 1.317  + lamda*(-3.33573e-3 + 2.1429e-4*lamda);
		double red = cPixSpec[rrnd].getRed() + 
			(cPixSpec[rrnd+1].getRed() - cPixSpec[rrnd].getRed())*(lamda - rrnd);
		double green = cPixSpec[rrnd].getGreen() + 
			(cPixSpec[rrnd+1].getGreen() - cPixSpec[rrnd].getGreen())*(lamda - rrnd);
		double blue = cPixSpec[rrnd].getBlue() + 
			(cPixSpec[rrnd+1].getBlue() - cPixSpec[rrnd].getBlue())*(lamda - rrnd);
		cPix = new Color((int)red, (int)green, (int)blue, 170);
		index = index0;
		indexSq = index*index;
	}
	
/************************************************************************/
	static Color AddColor(Color cPix1, Color cPix2) {//Not used in present implementation
		double red = cPix1.getRed()*0.9 + cPix2.getRed()*0.1;
		double green = cPix1.getGreen()*0.9 + cPix2.getGreen()*0.1;
		double blue = cPix1.getBlue()*0.9 + cPix2.getBlue()*0.1;
		Color color = new Color((int)red, (int)green, (int)blue);
		return color;
	}
	
/************************************************************************/
	public char RelationArray(int i, int j) { //Relates crystal faces
			String[] relString = new String[8];
		/*		(1,1)=homo 
				(1,2)=ortho   
				(1,3)=meta  
				(1,5)=para and so on.
				homo  = the same (should never occur) 
				ortho = nearest neighbour 
				meta  = next neighbour
				para  = opposite   */
		relString[1] = "-hom-pmo";
		relString[2] = "-oho-mpm";
		relString[3] = "-moh-omp";
		relString[4] = "P---H---";
		relString[5] = "-pmo-hom";
		relString[6] = "-mpm-oho";
		relString[7] = "-omp-moh";
		relString[0] = "H---P---";
		
		return relString[i].charAt(j);
	}
	
/************************************************************************/
	public int[] DecodeHistory(int history) {
		int step = 0;
		while (history > 0) { //Step down one step
			history = history << 1;
			step = step + 1; 
		}
		int n = 10 - (step - 1)/3; //There are 30 steps, each face is save as a three bits (0-7)
		int[] result = new int[n+1];//Container for the result
		history = history >>> step;//Step down up logical to get an initial zero
		for (int i=1; i<=n; i++) {//Extract the history, one by one in inverse order
			int b = history & 7;
			result[n-i] = b;
			history = history >>> 3;
		}
		result[n] = -1;
		return result;
	}
	
/************************************************************************/
	public String AnalyseEvent(int history) {
		String hStr = "";
		int[] digit = new int[10];
		int saveEnd = -1, saveSide = -1;
		boolean foundFirstEnd = false, foundFirstSide = false, ErrEvnt = false;
		
		digit = DecodeHistory(history);
		//Faces are here numbered 1,2,3,5,6,7 for prism faces, 4 and 0 are basal faces
		int j = 0;
		while (digit[j] != -1) {//while
			if (digit[j] == 4 || digit[j] == 0) {	//It is base face
				if (!foundFirstEnd) {				//The first one
					foundFirstEnd = true;
					saveEnd = digit[j];				//Save the face
					hStr = hStr +'E';
				} else {
					hStr = hStr + RelationArray(saveEnd, digit[j]);//Find relation
					saveEnd = digit[j];				//Save the face
				} 
			} else {
				if (!foundFirstSide) { // Is a prism face, the first one
						foundFirstSide = true;
						saveSide = digit[j];		//Save the side
						hStr = hStr + 's';
				} else {						//not the first prism
						hStr = hStr + RelationArray(saveSide, digit[j]);
						saveSide = digit[j]; // Save the face
				}
			}
			j = j + 1;
		}//while
		return hStr;
	}
	
/************************************************************************/
	public void SaveSpatialData() {
		PrintWriter outFile = null;;
		String name = "SpatialData";
		
		FileDialog fd = new FileDialog(jf);
		fd.setMode(FileDialog.SAVE);
		fd.setFile(name);
		fd.setVisible(true);
		String s1 = fd.getFile();
		String s2 = fd.getDirectory();
		name = s2 + s1 +".txt";
		if (s2 != null) {
			try{
				outFile = new PrintWriter(new BufferedWriter(
							new FileWriter(name)));
			} catch (Exception e0) {System.out.println("OPEN ERROR");}
		}
		
		String tempString1 = "";
		String tempString2 = "";
		String tempString3 = "";
		double distance, x, y, z;
		
		for (Event e : eventList) {//Step through the list
			distance = e.pixelVector[3]/10000.0;
			x = -distance*e.pixelVector[4]/10000.0;
			y = -distance*e.pixelVector[5]/10000.0;
			z = -distance*e.pixelVector[6]/10000.0;
			tempString1 = String.format("%7.4f", x);
			tempString2 = String.format("%7.4f", y);
			tempString3 = String.format("%7.4f", z);
			tempString1 = tempString1.trim();
			tempString2 = tempString2.trim();
			tempString3 = tempString3.trim();
			String result = tempString1+"\t"+tempString2+"\t"+tempString3;
			result = result.replace(",",".");
			try {
				outFile.println(result);
			} catch (Exception e0) {System.out.println("PRINT ERROR");}
		}
		outFile.close();
	}

/************************************************************************/
	public void HandleRayHistories(Rectangle rect) {
		int[] numberBin = new int[1000];
		String[] wordBin = new String[1000];

		int binNumber = 0;	
		for (Event e : eventList) {//Step through the list
			int history = e.pixelVector[0];//Get the history...
			int x = e.pixelVector[1];//and the location
			int y = e.pixelVector[2];
			if (rect.contains(x,y)) {//Location in the marked rectangle?
				String str = AnalyseEvent(history); //Decode and convert history to string
				boolean foundWord = false; //Not found anything yet
				for (int counter=0; counter < binNumber; counter++) {//Step through the bins
					if (str.equals(wordBin[counter])) {		//We found a twin string
						numberBin[counter] = numberBin[counter] + 1;//Update the number of the bin
						foundWord = true; //Tell them we found a twin
					}
				}
				if (!foundWord) { //We didn't find a twin
					numberBin[binNumber] = 1; //Start up a new bin...
					wordBin[binNumber] = str; //and a word bin
					binNumber = binNumber + 1;//One more bin
				}
			}
		}

		bubbleSort(numberBin, wordBin, binNumber);//Sort the nbins in decreasing order
		//Get the maximum string length
		int stringLength = 0;
		for (int i=0; i<binNumber; i++) 
			if (wordBin[i].length() > stringLength) stringLength = wordBin[i].length();
	
		String[] str = new String[binNumber]; //Concatenate the event data statistics
		for (int i=0; i< binNumber; i++) {
			String fill = "";
			for (int k=0; k< stringLength - wordBin[i].length(); k++) fill = fill + " ";
			str[i] = wordBin[i] + fill +String.format(" %5d", numberBin[i]) +"\n";
		}
	
		hf.setData(str, binNumber);//Port it to the HistoryFrame unit

	}
 	
/************************************************************************/
	public void bubbleSort(int[] data, String[] str, int dataLength) {
		boolean isSorted;
		int temp;
		String tempString;
		int numberOfTimesLooped = 0;

		do {
			isSorted = true;
			for (int i=1; i<dataLength - numberOfTimesLooped; i++) {
				if (data[i] > data[i-1]) {
					temp = data[i];
					data[i] = data[i-1];
					data[i-1] = temp;
					tempString = str[i];
					str[i] = str[i-1];
					str[i-1] = tempString;
					
					isSorted = false;
				}
			}
			numberOfTimesLooped++;
		} while(!isSorted)	;		
	}

/************************************************************************/

	public static void main(String args[]) {
		new Halo();
	 }

}