//
//  MakeStereo.java
//  Halo
//
//  Created by lars on 31/07/2009.
//  Copyright 2009 __MyCompanyName__. All rights reserved.
//

import java.awt.*;
import javax.swing.*;
import static java.lang.Math.*;

public class MakeStereo extends JPanel {

	public MakeStereo() {
		repaint();
	}
	
	public void paintComponent(Graphics g) {
//		super.paintComponent(g);
		double delta = 100; //Distance between the eyes
		double[] observer = new double[4];
		observer[1] = cos(Halo.elevation*PI/180);
		observer[2] = 0;
		observer[3] = sin(Halo.elevation*PI/180);
		System.out.println(Halo.blackSky);
		if (Halo.blackSky) g.setColor(Color.black);
		else g.setColor(Color.white);
		g.fillRect(0,0,1110,610);
		if (Halo.blackSky) g.setColor(Color.white);
		else g.setColor(Color.black);
		if (Halo.fisheye) {
			g.drawOval(10, 10, 540, 540);
			g.drawOval(560, 10, 540, 540);
		} else {
			g.drawRect(10, 10, 540, 540);
			g.drawRect(560, 10, 540, 540);
			delta = 25;
		}
		int b1P, b2P, b1M, b2M, b2;
		for (Halo.Event e : Halo.eventList) {//Step through the events
			double dx = e.pixelVector[3]; //Extract the data: The distance to the crystal
			double x = e.pixelVector[4]/10000.0;//The direction vector to the crystal
			double y = e.pixelVector[5]/10000.0;
			double z = e.pixelVector[6]/10000.0;
			double d = sqrt(x*x+y*y+z*z);
			x = x * dx / d;//Put crystal at correct distance
			y = y * dx / d;
			z = z * dx / d;
			double yP = y + delta;//Translate to the two eyes
			double yM = y - delta;
			if (Halo.fisheye) {
				double ggP = sqrt(x*x+yP*yP);//Make the fisheye projection
				double ggM = sqrt(x*x+yM*yM);
				b1P = (int)(atan(ggP/z)*2/PI*x/ggP*270);
				b2P = (int)(atan(ggP/z)*2/PI*yP/ggP*270);
				b1M = (int)(atan(ggM/z)*2/PI*x/ggM*270);
				b2M = (int)(atan(ggM/z)*2/PI*yM/ggM*270);
			} else {
				x = - x;
				yP = - yP;
				yM = - yM;
				z = - z;
				double temp = x;
				x = -x*observer[1] - z*observer[3]; //Center sun
				z = temp*observer[3] - z*observer[1];
				z = 270 * z / x;
				yP = 270 * yP / x;
				yM = 270 * yM / x;
				b2P =(int)(yP + 0.5);
				b2M =(int)(yM + 0.5);
				b1P = (int)(- z + 0.5);
				b1M = b1P;				
			}
			if (!Halo.crossEyed) {		//Put the pictures in the right order
				g.fillRect(b2M+280, b1M + 280, 1, 1);
				g.fillRect(b2P+830, b1P + 280, 1, 1);
			} else {
				g.fillRect(b2P+280, b1P + 280, 1, 1);
				g.fillRect(b2M+830, b1M + 280, 1, 1);
			}
		}
	}

}
